import java.io.*;
import java.util.*;
import java.util.regex.*;

        class ML2SVG
        {
                YYARec[] yya;
                YYARec[] yyg;
                YYRRec[] yyr;
                int[] yyd;
                int[] yyal;
                int[] yyah;
                int[] yygl;
                int[] yygh;

                int yyn = 0;
                int yystate = 0;
                int yychar = -1;
                int yynerrs = 0;
                int yyerrflag = 0;
                int yysp = 0;
                int yymaxdepth = 1024;
                int yyflag = 0;
                int yyfnone   = 0;
                int[] yys = new int[1024];
                String[] yyv = new String[1024];

                String yyval = "";

                public static class TOutput extends PrintWriter { 
                 public TOutput(BufferedWriter b) { super(b); }
                 public TOutput(PrintStream s) { super(s); }
                 public void WriteLine(String s) { println(s); } 
                }
                TOutput Output;

                class YYARec
                {
                        public int sym;
                        public int act;
                        public YYARec (int s, int a){ sym = s; act = a; }
                }

                class YYRRec
                {
                        public int len;
                        public int sym;
                        public YYRRec (int l, int s){ sym = s; len = l; }
                }

                ////////////////////////////////////////////////////////////////
                /// Constant values / tokens
                ////////////////////////////////////////////////////////////////
                int t_Minus = 257;
                int t_A = 258;
                int t_C = 259;
                int t_D = 260;
                int t_E = 261;
                int t_F = 262;
                int t_G = 263;
                int t_H = 264;
                int t_T_0 = 265;
                int t_T_1 = 266;
                int t_T_2 = 267;
                int t_T_16 = 268;
                int t_T_32 = 269;
                int t_T_4 = 270;
                int t_T_8 = 271;
                int t_P = 272;
                int t_ignore = 256;
///////////////////////////////////////////////////////////
/// Global settings: 
///////////////////////////////////////////////////////////
int x = 60;
int sum = 0;

///////////////////////////////////////////////////////////


                /// <summary>
                /// Der Haupteinstiegspunkt fr die Anwendung.
                /// </summary>
                public static void main(String[] args)
                {
                        ML2SVG compiler = new ML2SVG();
                        String inputstream = "";

                        boolean ShowTokens = false;
                        String InputFilename = "";
                        String OutputFilename = "";

                        for (String s : args)
                        {
                                if (s.toLowerCase().equals("-t"))
                                {
                                        ShowTokens = true;
                                }
                                else
                                {
                                        if (InputFilename.equals(""))  InputFilename = s; else
                                        if (OutputFilename.equals("")) OutputFilename = s; else
                                        {
                                                System.out.println("Too many arguments!");
                                                System.exit(1);
                                        }
                                }
                        }
                        if (InputFilename.equals(""))
                        {
                                System.out.println("You need to specify input and outputfile: compiler.exe input.txt output.txt");
                                System.exit(1);
                        }

                        try{

						FileInputStream in=new FileInputStream(InputFilename);
						int len=in.available();
						for(int i=1;i<=len;i++)
						{
						   inputstream += (char)in.read();
						}
                        in.close();

                        ////////////////////////////////////////////////////////////////
                        /// Compiler Code:
                        ////////////////////////////////////////////////////////////////

			

                        compiler.Output = null;
                        if (!OutputFilename.equals(""))
                        {
                                File myFile = new File(OutputFilename);
                                myFile.delete();
                                compiler.Output = new TOutput(new BufferedWriter(new FileWriter(OutputFilename)));
                        }
                        else
                        {
                                compiler.Output = new TOutput(System.out);
                        }
                        }catch (Exception e) {e.printStackTrace(); System.exit(1);}

                        if (!compiler.Scanner(inputstream)) System.exit(1);
                        if (ShowTokens)
                        {
                                for (Object o : compiler.TokenList)
                                {
                                        AToken t = (AToken)o;
                                        System.out.println("TokenID: "+t.token+"  =  "+t.val);
                                }
                        }
                        compiler.InitTables();
                        if(!compiler.yyparse()) System.exit(1);

                        if (compiler.Output != null) compiler.Output.close();			
                }
                public void yyaction (int yyruleno)
                {
                        switch (yyruleno)
                        {
                                ////////////////////////////////////////////////////////////////
                                /// YYAction code:
                                ////////////////////////////////////////////////////////////////
							case    1 : 
         yyval = "<?xml version=\"1.0\" ?>\r\n";
         yyval += "<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20010904//EN\" \"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\r\n";
         yyval += "<svg width=\"1200\" height=\"100\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\">\r\n";
         yyval += " <rect x=\"0\" y=\"0\" width=\"1200\" height=\"100\" fill=\"lightyellow\" />\r\n";
         yyval += " <line x1=\"0\" y1=\"30\" x2=\"1200\" y2=\"30\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += " <line x1=\"0\" y1=\"40\" x2=\"1200\" y2=\"40\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += " <line x1=\"0\" y1=\"50\" x2=\"1200\" y2=\"50\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += " <line x1=\"0\" y1=\"60\" x2=\"1200\" y2=\"60\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += " <line x1=\"0\" y1=\"70\" x2=\"1200\" y2=\"70\" style=\"stroke:black;stroke-width:2\"/>\r\n";
         yyval += " <g transform=\"scale(0.3), translate(-30,5)\">\r\n";
         yyval += " <path style=\"fill:black;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1\"\r\n";
         yyval += " d=\"M 69.5,269 C 109.49865,237.74085 32.262361,224.08824 56,272 C 61.182004,282.45929 111.5,308.5147 111.5,232 C 111.5,174.5";
         yyval += " 76.5,101.5 76.5,72.5 C 76.5,43.5 99.5,28 99.5,66.5 C 99.5,105 43,138 43,178 C 43,244.03444 133.5,245.03362 133.5,196";
         yyval += " C 133.5,150.49725 91.173308,149.09646 77.5,160.5 C 57.985811,176.77483 65.057032,208.40019 88,210.5 C 54.34356,167.39365";
         yyval += " 119.69526,156.08817 124,192.5 C 128.73256,232.53051 54.5,233.66467 54.5,185 C 54.5,146.5 115.77186,107.39877 113,69.5";
         yyval += " C 109,14.809305 73.139128,-2.0985557 69,64.5 C 66.090245,110.81795 103.83053,169.51937 105.5,235 C 106.56602,276.81169";
         yyval += " 75.181981,287.85355 69.5,269 z \"/>\r\n";
         yyval += " </g>\r\n";
         yyval += "<line x1=\"40\" y1=\"30\" x2=\"40\" y2=\"70\" style=\"stroke:black;stroke-width:2\" />\r\n";
         yyval += yyv[yysp-0]+"\r\n";
         yyval += "</svg>";
         Output.WriteLine(yyval);
         
       break;
							case    2 : 
         yyval = yyv[yysp-0];
         
       break;
							case    3 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    4 : 
         int cy = 0;
         
         if (yyv[yysp-2].equals("C0")) cy = 80;  if (yyv[yysp-2].equals("C1")) cy = 45;
         if (yyv[yysp-2].equals("D0")) cy = 75;  if (yyv[yysp-2].equals("D1")) cy = 40;
         if (yyv[yysp-2].equals("E0")) cy = 70;  if (yyv[yysp-2].equals("E1")) cy = 35;
         if (yyv[yysp-2].equals("F0")) cy = 65;  if (yyv[yysp-2].equals("F1")) cy = 30;
         if (yyv[yysp-2].equals("G0")) cy = 60;  if (yyv[yysp-2].equals("G1")) cy = 25;
         if (yyv[yysp-2].equals("A0")) cy = 55;  if (yyv[yysp-2].equals("A1")) cy = 20;
         if (yyv[yysp-2].equals("H0")) cy = 50;  if (yyv[yysp-2].equals("H1")) cy = 15;
         
         yyval = "<ellipse cx=\"" +x+ "\" cy=\""+cy+"\" rx=\"8\" ry=\"5\" style=\"fill:black;\"/>";
         
         if (yyv[yysp-0].equals("2") || yyv[yysp-0].equals("4") || yyv[yysp-0].equals("8"))  
         yyval = yyval + "<line x1=\""+(x+8)+"\" y1=\"" + cy +"\" x2=\""+(x+8)+"\" y2=\""+ (cy-30)+"\" style=\"stroke:black;stroke-width:2\" />"; 
         
         if (yyv[yysp-0].equals("1") || yyv[yysp-0].equals("2"))   
         yyval = yyval + "<ellipse cx=\"" +x+ "\" cy=\""+cy+"\" rx=\"3\" ry=\"4\" style=\"fill:white;\"/>"; 
         
         if (yyv[yysp-0].equals("8"))  
         yyval = yyval + "<path d=\"M "+(x+8)+"," + (cy-30) +" q 0,10 5,10 t 5,10\" style=\"stroke:black;\" />"; 
         
         if (yyv[yysp-0].equals("1"))  sum += 32;
         if (yyv[yysp-0].equals("2"))  sum += 16;
         if (yyv[yysp-0].equals("4"))  sum += 8;
         if (yyv[yysp-0].equals("8"))  sum += 4;
         if (yyv[yysp-0].equals("16")) sum += 2;
         if (yyv[yysp-0].equals("32")) sum += 1;
         
         if (sum >= 32) {
         x += 20;
         sum -= 32; 
         yyval = yyval + "<line x1=\""+(x+8)+"\" y1=\"30\" x2=\""+(x+8)+"\" y2=\"70\" style=\"stroke:black;stroke-width:2\" />"; 
         x -= 10;
         }
         x += 40;
         
       break;
							case    5 : 
         if (yyv[yysp-0].equals("1")) {
         yyval = " <rect x=\""+x+"\" y=\"40\" width=\"16\" height=\"5\" fill=\"black\" />\r\n";
         }
         if (yyv[yysp-0].equals("2")) {
         yyval = " <rect x=\""+x+"\" y=\"45\" width=\"16\" height=\"5\" fill=\"black\" />\r\n";
         }
         
         if (yyv[yysp-0].equals("4")) {
         yyval = "<g transform=\"translate("+(x-80)+",-100)\">"+
         " <path d=\"M 77.27711,137.67547 C 78.1102,138.5641 84.49724,146.39515 84.49724,146.39515 C 84.49724,146.39515 "+
         "  80.94271,149.78305 80.94271,153.33758 C 80.94271,157.50303 85.7191,161.27971 85.7191,161.27971 L 85.21925,161.89064 "+
         "  C 83.38645,160.8354 80.27624,160.72432 78.88776,162.33496 C 77.16603,164.33438 81.05379,167.38904 81.05379,167.38904 "+
         "  L 80.60948,167.99998 C 79.27653,167.00027 73.61151,161.66849 75.99971,159.05813 C 77.44373,157.44749 79.22099,156.94764 "+
         "  81.72027,158.28058 L 75,151.33816 C 78.88776,146.56177 79.55423,145.17328 79.55423,143.89588 C 79.55423,141.22999 77.66589,139.34165"+
         "  76.72172,138.11978 C 76.38848,137.61993 75.77755,137.23115 76.16633,136.89791 C 76.5551,136.62022 76.77726,137.06453 77.27711,137.67547 z \"/>"+
         "</g>";
         }
         if (yyv[yysp-0].equals("8")) {
         yyval = "<g transform=\"translate("+(x-80)+",-180)\">"+
         "  <path d=\"M 79.952454,242.74998 L 81.702454,242.74998 L 86.484624,224.39015 C 84.012934,226.53789 82.550624,228.31759"+
         "   80.467614,228.56248 C 80.467614,228.56248 81.268864,227.56014 81.196474,225.80187 C 81.126654,224.10599 80.209734,223.05449"+
         "   78.385504,222.98926 C 76.623694,222.92626 75.121824,224.63888 75.258674,226.41343 C 75.395974,228.19385 77.144614,229.69521"+
         "   78.519804,229.68317 C 82.372634,229.64944 84.459954,227.77762 85.681004,225.63126 L 79.952454,242.74998 z \""+
         "   style=\"fill:black;fill-opacity:1;fill-rule:evenodd;stroke:black;stroke-width:0.5;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1\"/>"+
         "</g>";
         }
         if (yyv[yysp-0].equals("16")) {
         yyval = "<g transform=\"translate("+(x-80)+",-250)\">"+
         " <path d=\"M 81.097529,317.74998 L 91.407239,288.36775 C 89.310549,290.51549 87.609149,292.21462 85.452729,292.85258"+
         "  C 85.875969,292.04682 86.563139,291.5134 86.556589,290.40447 C 86.548489,289.12165 85.475949,287.16736 82.995619,287.21686"+
         "  C 80.577789,287.26636 79.675969,288.96047 79.618789,290.57853 C 79.559399,292.25901 80.703419,293.99761 83.067419,294.09827"+
         "  C 85.440019,294.1993 89.382569,292.56772 90.728619,289.42136 C 90.003199,291.01459 87.500989,298.11487 86.131349,300.9883"+
         "  C 84.574209,303.23673 82.415469,304.86173 81.250069,305.16508 C 81.959669,303.96843 82.225039,303.32521 82.157239,302.26419"+
         "  C 82.050499,300.59379 80.705159,299.15679 78.657229,299.13919 C 76.607809,299.12158 75.262489,300.53688 75.250069,302.66508"+
         "  C 75.237659,304.792 76.892209,306.08687 78.625069,306.10258 C 82.529219,306.13798 84.431569,304.24315 85.849179,301.68653"+
         "  L 79.440649,317.70614 L 81.097529,317.74998 z \""+
         "  style=\"fill:black;fill-opacity:1;fill-rule:evenodd;stroke:black;stroke-width:0.5;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1\"/>"+
         "</g>";
         }
         if (yyv[yysp-0].equals("32")) {
         yyval = "<g transform=\"translate("+(x-80)+",-320)\">"+
         " <path d=\"M 79.760774,392.75 L 81.885782,392.75 L 95.543,353.8277 C 93.446302,355.9754 91.744896,357.6745 89.588469,358.3125"+
         "  C 90.01171,357.5067 90.698883,356.9733 90.692333,355.8644 C 90.684232,354.5816 89.611689,352.6273 87.13135,352.6768 C 84.713512,352.7263"+
         "  83.811688,354.4204 83.754508,356.0384 C 83.695118,357.7189 84.839142,359.4575 87.20315,359.5582 C 89.575759,359.6592 93.518322,358.0276"+
         "  94.864377,354.8813 C 94.138955,356.4745 91.636736,363.5748 90.267091,366.4482 C 88.709946,368.6966 86.551198,370.3216 85.385794,370.625"+
         "  C 86.095396,369.4283 86.360767,368.7851 86.292967,367.7241 C 86.186227,366.0537 84.840882,364.6167 82.792945,364.5991 C 80.743518,364.5815"+
         "  79.398193,365.9968 79.385773,368.125 C 79.373363,370.2519 81.027919,371.5468 82.760785,371.5625 C 86.664948,371.5979 88.567305,369.7031"+
         "  89.98492,367.1464 C 89.98492,367.1464 87.353901,373.4902 85.969746,377.2348 C 85.398094,378.1045 82.656774,380.4223 81.38578,380.6875"+
         "  C 81.927292,379.8277 82.167933,379.7678 82.135782,378.358 C 82.103632,376.8857 80.578117,375.2356 78.6831,375.1812 C 76.785254,375.1267"+
         "  75.242448,376.4505 75.250028,378.5259 C 75.257608,380.6001 76.968604,382.149 78.62949,382.1509 C 81.868122,382.1545 84.22326,380.6695"+
         "  85.327734,378.767 L 79.760774,392.75 z \""+
         "  style=\"fill:black;fill-opacity:1;fill-rule:evenodd;stroke:black;stroke-width:0.50000089;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1\"/>"+
         "</g>";
         }
         x += 40;
         
       break;
							case    6 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    7 : 
         yyval = yyv[yysp-0];
         
       break;
							case    8 : 
         yyval = yyv[yysp-0];
         
       break;
							case    9 : 
         yyval = yyv[yysp-0];
         
       break;
							case   10 : 
         yyval = yyv[yysp-0];
         
       break;
							case   11 : 
         yyval = yyv[yysp-0];
         
       break;
							case   12 : 
         yyval = yyv[yysp-0];
         
       break;
							case   13 : 
         yyval = yyv[yysp-0];
         
       break;
							case   14 : 
         yyval = yyv[yysp-0];
         
       break;
							case   15 : 
         yyval = yyv[yysp-0];
         
       break;
							case   16 : 
         yyval = yyv[yysp-0];
         
       break;
							case   17 : 
         yyval = yyv[yysp-0];
         
       break;
							case   18 : 
         yyval = yyv[yysp-0];
         
       break;
							case   19 : 
         yyval = yyv[yysp-0];
         
       break;
							case   20 : 
         yyval = yyv[yysp-0];
         
       break;
							case   21 : 
         yyval = yyv[yysp-0];
         
       break;
							case   22 : 
         yyval = yyv[yysp-0];
         
       break;
							case   23 : 
         yyval = yyv[yysp-0];
         
       break;
                                default : return;
                        }
                }

                public void InitTables()
                {
                        ////////////////////////////////////////////////////////////////
                        /// Init Table code:
                        ////////////////////////////////////////////////////////////////

					int yynacts   = 35;
					int yyngotos  = 14;
					int yynstates = 30;
					int yynrules  = 23;
					yya = new YYARec[yynacts+1];  int yyac = 1;
					yyg = new YYARec[yyngotos+1]; int yygc = 1;
					yyr = new YYRRec[yynrules+1]; int yyrc = 1;

					yya[yyac] = new YYARec(258,7);yyac++; 
					yya[yyac] = new YYARec(259,8);yyac++; 
					yya[yyac] = new YYARec(260,9);yyac++; 
					yya[yyac] = new YYARec(261,10);yyac++; 
					yya[yyac] = new YYARec(262,11);yyac++; 
					yya[yyac] = new YYARec(263,12);yyac++; 
					yya[yyac] = new YYARec(264,13);yyac++; 
					yya[yyac] = new YYARec(272,14);yyac++; 
					yya[yyac] = new YYARec(265,16);yyac++; 
					yya[yyac] = new YYARec(266,17);yyac++; 
					yya[yyac] = new YYARec(267,18);yyac++; 
					yya[yyac] = new YYARec(257,19);yyac++; 
					yya[yyac] = new YYARec(257,20);yyac++; 
					yya[yyac] = new YYARec(258,7);yyac++; 
					yya[yyac] = new YYARec(259,8);yyac++; 
					yya[yyac] = new YYARec(260,9);yyac++; 
					yya[yyac] = new YYARec(261,10);yyac++; 
					yya[yyac] = new YYARec(262,11);yyac++; 
					yya[yyac] = new YYARec(263,12);yyac++; 
					yya[yyac] = new YYARec(264,13);yyac++; 
					yya[yyac] = new YYARec(272,14);yyac++; 
					yya[yyac] = new YYARec(0,-2 );yyac++; 
					yya[yyac] = new YYARec(0,0);yyac++; 
					yya[yyac] = new YYARec(266,23);yyac++; 
					yya[yyac] = new YYARec(267,24);yyac++; 
					yya[yyac] = new YYARec(268,25);yyac++; 
					yya[yyac] = new YYARec(269,26);yyac++; 
					yya[yyac] = new YYARec(270,27);yyac++; 
					yya[yyac] = new YYARec(271,28);yyac++; 
					yya[yyac] = new YYARec(266,23);yyac++; 
					yya[yyac] = new YYARec(267,24);yyac++; 
					yya[yyac] = new YYARec(268,25);yyac++; 
					yya[yyac] = new YYARec(269,26);yyac++; 
					yya[yyac] = new YYARec(270,27);yyac++; 
					yya[yyac] = new YYARec(271,28);yyac++;

					yyg[yygc] = new YYARec(-8,1);yygc++; 
					yyg[yygc] = new YYARec(-7,2);yygc++; 
					yyg[yygc] = new YYARec(-5,3);yygc++; 
					yyg[yygc] = new YYARec(-4,4);yygc++; 
					yyg[yygc] = new YYARec(-3,5);yygc++; 
					yyg[yygc] = new YYARec(-2,6);yygc++; 
					yyg[yygc] = new YYARec(-9,15);yygc++; 
					yyg[yygc] = new YYARec(-8,1);yygc++; 
					yyg[yygc] = new YYARec(-7,2);yygc++; 
					yyg[yygc] = new YYARec(-5,3);yygc++; 
					yyg[yygc] = new YYARec(-4,4);yygc++; 
					yyg[yygc] = new YYARec(-3,21);yygc++; 
					yyg[yygc] = new YYARec(-6,22);yygc++; 
					yyg[yygc] = new YYARec(-6,29);yygc++;

					yyd = new int[yynstates];
					yyd[0] = 0;  
					yyd[1] = 0;  
					yyd[2] = 0;  
					yyd[3] = 0;  
					yyd[4] = 0;  
					yyd[5] = -1;  
					yyd[6] = 0;  
					yyd[7] = -7;  
					yyd[8] = -8;  
					yyd[9] = -9;  
					yyd[10] = -10;  
					yyd[11] = -11;  
					yyd[12] = -12;  
					yyd[13] = -13;  
					yyd[14] = -23;  
					yyd[15] = -6;  
					yyd[16] = -14;  
					yyd[17] = -15;  
					yyd[18] = -16;  
					yyd[19] = 0;  
					yyd[20] = 0;  
					yyd[21] = -3;  
					yyd[22] = -5;  
					yyd[23] = -17;  
					yyd[24] = -19;  
					yyd[25] = -18;  
					yyd[26] = -20;  
					yyd[27] = -21;  
					yyd[28] = -22;  
					yyd[29] = -4; 

					yyal = new int[yynstates];
					yyal[0] = 1;  
					yyal[1] = 9;  
					yyal[2] = 12;  
					yyal[3] = 13;  
					yyal[4] = 14;  
					yyal[5] = 23;  
					yyal[6] = 23;  
					yyal[7] = 24;  
					yyal[8] = 24;  
					yyal[9] = 24;  
					yyal[10] = 24;  
					yyal[11] = 24;  
					yyal[12] = 24;  
					yyal[13] = 24;  
					yyal[14] = 24;  
					yyal[15] = 24;  
					yyal[16] = 24;  
					yyal[17] = 24;  
					yyal[18] = 24;  
					yyal[19] = 24;  
					yyal[20] = 30;  
					yyal[21] = 36;  
					yyal[22] = 36;  
					yyal[23] = 36;  
					yyal[24] = 36;  
					yyal[25] = 36;  
					yyal[26] = 36;  
					yyal[27] = 36;  
					yyal[28] = 36;  
					yyal[29] = 36; 

					yyah = new int[yynstates];
					yyah[0] = 8;  
					yyah[1] = 11;  
					yyah[2] = 12;  
					yyah[3] = 13;  
					yyah[4] = 22;  
					yyah[5] = 22;  
					yyah[6] = 23;  
					yyah[7] = 23;  
					yyah[8] = 23;  
					yyah[9] = 23;  
					yyah[10] = 23;  
					yyah[11] = 23;  
					yyah[12] = 23;  
					yyah[13] = 23;  
					yyah[14] = 23;  
					yyah[15] = 23;  
					yyah[16] = 23;  
					yyah[17] = 23;  
					yyah[18] = 23;  
					yyah[19] = 29;  
					yyah[20] = 35;  
					yyah[21] = 35;  
					yyah[22] = 35;  
					yyah[23] = 35;  
					yyah[24] = 35;  
					yyah[25] = 35;  
					yyah[26] = 35;  
					yyah[27] = 35;  
					yyah[28] = 35;  
					yyah[29] = 35; 

					yygl = new int[yynstates];
					yygl[0] = 1;  
					yygl[1] = 7;  
					yygl[2] = 8;  
					yygl[3] = 8;  
					yygl[4] = 8;  
					yygl[5] = 13;  
					yygl[6] = 13;  
					yygl[7] = 13;  
					yygl[8] = 13;  
					yygl[9] = 13;  
					yygl[10] = 13;  
					yygl[11] = 13;  
					yygl[12] = 13;  
					yygl[13] = 13;  
					yygl[14] = 13;  
					yygl[15] = 13;  
					yygl[16] = 13;  
					yygl[17] = 13;  
					yygl[18] = 13;  
					yygl[19] = 13;  
					yygl[20] = 14;  
					yygl[21] = 15;  
					yygl[22] = 15;  
					yygl[23] = 15;  
					yygl[24] = 15;  
					yygl[25] = 15;  
					yygl[26] = 15;  
					yygl[27] = 15;  
					yygl[28] = 15;  
					yygl[29] = 15; 

					yygh = new int[yynstates];
					yygh[0] = 6;  
					yygh[1] = 7;  
					yygh[2] = 7;  
					yygh[3] = 7;  
					yygh[4] = 12;  
					yygh[5] = 12;  
					yygh[6] = 12;  
					yygh[7] = 12;  
					yygh[8] = 12;  
					yygh[9] = 12;  
					yygh[10] = 12;  
					yygh[11] = 12;  
					yygh[12] = 12;  
					yygh[13] = 12;  
					yygh[14] = 12;  
					yygh[15] = 12;  
					yygh[16] = 12;  
					yygh[17] = 12;  
					yygh[18] = 12;  
					yygh[19] = 13;  
					yygh[20] = 14;  
					yygh[21] = 14;  
					yygh[22] = 14;  
					yygh[23] = 14;  
					yygh[24] = 14;  
					yygh[25] = 14;  
					yygh[26] = 14;  
					yygh[27] = 14;  
					yygh[28] = 14;  
					yygh[29] = 14; 

					yyr[yyrc] = new YYRRec(1,-2);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-5);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-9);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-9);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-9);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++;
                }

                public boolean yyact(int state, int sym)
                {
                        int k = yyal[state];
                        while ( k <= yyah[state] && yya[k].sym != sym) k++;
                        if (k > yyah[state]) return false;
                        yyn = yya[k].act;
                        return true;
                }
                public boolean yygoto(int state, int sym)
                {
                        int k = yygl[state];
                        while ( k <= yygh[state] && yyg[k].sym != sym) k++;
                        if (k > yygh[state]) return false;
                        yyn = yyg[k].act;
                        return true;
                }

                public void yyerror (String s)
                {
                        System.out.println(s);
                }

                int yylexpos = -1;
                String yylval = "";

                public int yylex ()
                {
                        yylexpos++;
                        if(yylexpos >= TokenList.size())
                        {
                                yylval = "";
                                return 0;
                        }
                        else
                        {
                                yylval = ((AToken)TokenList.get(yylexpos)).val;
                                return ((AToken)TokenList.get(yylexpos)).token;
                        }
                }


                public boolean yyparse ()
                {
                        boolean jumpToNext = false;
                        while(true){ // Parse:
                        if (!jumpToNext){
                        yysp++;
                        if (yysp>yymaxdepth)
                        {
                                yyerror("yyparse stack overflow");
                                return false;
                        }

                        yys[yysp] = yystate;
                        yyv[yysp] = yyval;
                        }
                        jumpToNext = false;

                        if (yyd[yystate]==0 && yychar==-1)
                        {
                            yychar = yylex();
                            if (yychar<0) yychar = 0;
                        }

                        yyn = yyd[yystate];
                        if (yyn != 0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }

                        if (! yyact(yystate, yychar)) {
                          if (yyerrflag==0) yyerror("syntax error");
                          int r = yy_errlab();
                          if (r == 0) return false;
                          if (r == 1) continue;
                          if (r == 2) {jumpToNext = true; continue; }
                        }
                        else if (yyn>0) {
                         /// shift:
                         yystate = yyn;
                         yychar = -1;
                         yyval = yylval;
                         if (yyerrflag>0) yyerrflag--;
                         continue; // PARSE:
                         ///////////////
                        }
                        else if (yyn<0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }
                        else return true;
                        } // WHILE Parse:
                }

                public int yy_errlab (){
                        if (yyerrflag==0) yynerrs++;
                        if (yyerrflag<=2)
                        {
                                yyerrflag = 3;
                                while (yysp>0 && !(yyact(yys[yysp], 255) && yyn > 0)) yysp--;

                                if (yysp==0) return 0;
                                yystate = yyn;
                                return 1; // PARSE:
                        }
                        else
                        {
                                if (yychar==0) return 0;
                                yychar = -1;
                                return 2;
                        }
                }
		////////////////////////////////////////////////////////////////
		/// Scanner
		////////////////////////////////////////////////////////////////

		public class AToken
		{
			public int token;
			public String val;
		}

		ArrayList<AToken> TokenList = new ArrayList<AToken>();

		public boolean Scanner (String Input)
		{
		        if (Input.length() == 0) return true;
			TokenList = new ArrayList<AToken>();
			while (1==1)
			{
				AToken lasttoken = FindToken(Input);
				if (lasttoken.token == 0) break;
				if (lasttoken.token != t_ignore) TokenList.add(lasttoken);
				if (Input.length() > lasttoken.val.length())
				Input = Input.substring(lasttoken.val.length()); else return true;
			}
                      System.out.println(Input);
			System.out.println();
			System.out.println("No matching token found!");
			return false;
		}
		public AToken FindToken (String Rest)
		{
			ArrayList<Integer> Results  = new ArrayList<Integer>();
			ArrayList<String> ResultsV = new ArrayList<String>();
                      try{

                        Pattern p;
                        Matcher m;
                      p = Pattern.compile("^(\\-)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_Minus));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(A)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_A));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(C)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_C));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(D)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_D));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(E)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_E));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(F)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_F));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(G)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_G));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(H)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_H));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(0)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_0));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(1)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_1));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(2)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_2));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(16)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_16));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(32)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_32));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(4)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_4));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(8)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_8));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(P)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_P));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^([\\r\\n\\t\\s])");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_ignore));
				ResultsV.add(m.group());}

			} catch (Exception e) {}
			int maxlength = 0;
			int besttoken = 0;
			AToken ret = new AToken();
		        ret.token = besttoken;
			for (int i = 0; i < Results.size(); i++){
				if (ResultsV.get(i).toString().length() > maxlength)
				{
					maxlength = ResultsV.get(i).toString().length();
					besttoken = ((Integer)Results.get(i)).intValue();
		         	        ret.token = besttoken;
		                  	if (besttoken != 0)
			                ret.val   = ResultsV.get(i).toString();
				}
			}
			return ret;
		}


	}
